const addBoxShadowToElement = (element, color) =>
  (element.style.boxShadow = `0 0 0.2rem 1.5rem ${color}`);

function intersectionTagElements(tagName = "p") {
  const THRESHOLD = 0.5;

  const intersectionHandle = (entries, observer) => {
    entries.forEach(entry => {
      const isVisible = entry.intersectionRatio >= THRESHOLD;

      addBoxShadowToElement(entry.target, isVisible ? "red" : "green");
    });
  };

  const observer = new IntersectionObserver(intersectionHandle, {
    threshold: THRESHOLD,
  });

  const elements = Array.from(document.getElementsByTagName(tagName));

  elements.forEach(el => observer.observe(el));
}


export default intersectionTagElements